struct Counter {
  count: u32,
}

impl Counter {
  fn new() -> Counter {
      Counter { count: 0 }
  }
}

impl Iterator for Counter {
  type Item = u32;

  fn next(&mut self) -> Option<Self::Item> {
      self.count += 1;
      Some(self.count)
  }
}

#[test]
fn test_counter() {
  let mut c = Counter::new();

  assert_eq!(c.next(), Some(1));
  assert_eq!(c.next(), Some(2));
  assert_eq!(c.next(), Some(3));
}
